import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class CubeMaker {

    /**converts the numbers 0,...,2^k to binary **/

    public static double[] binary(int K,int n) {
	int[] x=new int[K];
	int m=n;
	for(int count=0;count<K;++count) {
	    x[K-1-count]=m%2;
	    m=(m-x[K-1-count])/2;
	}
	double[] X=new double[K];
	for(int i=0;i<K;++i) X[i]=2.0*x[i]-1;
	return X;
    }

    public static double dot(int D,double[] a,double[] b) {
	double s=0;
	for(int i=0;i<D;++i) s=s+a[i]*b[i];
	return s;
    }
    /**graham schmidt*/

    public static double[][] grahamSchmidt(int D,double[][] V) {
	double[] W1=ortho(D,V[0],V[1]);
	double[] W0=unitize(D,V[0]);
	W1=unitize(D,W1);
	double[][] W={W0,W1};
	return W;
    }

    public static double[] ortho(int D,double[] V,double[] W) {
	double vw=dot(D,V,W);
	double vv=dot(D,V,V);
	double[] X=new double[W.length];
	for(int i=0;i<D;++i) {
	    X[i]=W[i]-(vw/vv)*V[i];
	}
	return X;
    }

    public static double[] unitize(int D,double[] V) {
	double v=Math.sqrt(dot(D,V,V));
 	double[] X=new double[V.length];
	for(int i=0;i<X.length;++i) {
	    X[i]=V[i]/v;
	}
	return X;
    }


    /**projection of dth vertex*/


    public static double[][] fromNavigator(int D,HSlider[][] NAV) {
	double[][] V=new double[2][8];
	for(int i=0;i<2;++i) {
	    for(int j=0;j<8;++j) {
		V[i][j]=NAV[i][j].getValue();
		if(j>D) V[i][j]=0;
	    }
	}
	return V;
    }

    public static Complex vertexProject(int D,double[] b,HSlider[][] NAV) {
	double[][] V=fromNavigator(D,NAV);
	V=grahamSchmidt(D,V);
	return vertexProject(D,b,V);
    }

    public static Complex vertexProject(int D,double[] b,double[][] V) {
	Complex z=new Complex(0,0);
 	z.x=dot(D,b,V[0]);
	z.y=dot(D,b,V[1]);
	return z;
    }

    public static Complex[] edgeProject(int D,int n,int nn,HSlider[][] NAV) {
	double[] L1=binary(D,n);
	double[] L2=binary(D,n);
	L2[nn]=-L2[nn];
	Complex Z1=vertexProject(D,L1,NAV);
	Complex Z2=vertexProject(D,L2,NAV);
	Complex[] Z={Z1,Z2};
	return(Z);
    }


    public static void printout(double[] x) {
	for(int i=0;i<x.length;++i) {
	    System.out.print(x[i]+" ");
	}
	System.out.println("");
    }

}

